# TD Components
该项目是通达OA前端组基于React、ant-design开发的一些公共组件，方便今后产品或其项目的使用。


## 安装说明

1. 下载或SVN检出该项文件命名为td-components，例如放在E盘根目录;
2. 在命令行中的E:\ 下执行 `npm install` 命令，成功后td-components文件夹下新增node_modules文件夹；
3. 在命令行中继续执行 `npm run antd` 命令，初始化 antd.css 文件；
4. 可以在src文件夹中新增组件的相关逻辑。



## 目录说明

td-components
>
>  dist
>
>  > libs  
>  > > jquery.mini.js  组件开发依赖于jquery
>
>  > > ...       可放置组件开发依赖的非react插件文件
>
>  > boudle.js   打包后输出的js文件
>
>  > index.css   各个组件打包后统一的样式文件
>
>  > index.html  打包后输出的静态文件
>
> example
>
>  > index.css   所有组件测试用例样式文件
>
>  > index.js    组件测试用例入口文件
>
>  src
>
>  > assets  
>
>  >  > tpl.html  静态模板文件夹
>
>  > components   所有基础组件
>
>  >  > componentName  一个文件夹是一个组件
>
>  >  >  > components  放置子组件
>
>  >  >  > index.jsx  组件入口
>
>  >  >  > index.css  组件样式文件
>
>  > blocks   所有区块组件
>
>  >  > componentName  一个文件夹是一个区块组件
>
>  >  >  > components  放置区块子组件
>
>  >  >  > index.jsx  区块组件入口
>
>  >  >  > index.css  区块组件样式文件
>
>  > index.css   所有组件测试用例样式文件
>
>  > index.js    组件开发入口文件
>
>  > ...        每个组件测试用例写一个.jsx文件，并在index.js中引用
>
> package.json  项目的配置文件
>  
> README.md     说明文件
>
> webpack.congfig.js  项目打包配置文件
>


## 调用说明

1. 在命令行中执行 `npm install td-components` 命令；
2. 在命令行中继续执行 `npm run antd` 命令，初始化 antd.css 文件；
3. 在命令行中继续执行 `npm run td-components` 命令，初始化 td.react.css 文件；
4. 在调用文件中写入 `import tdComponents from 'td-components'`；
5. 定义其中的一个组件 `const ComponentNames = tdComponents.ComponentNames`；
6. 在调用的地方`<ComponentNames />`直接使用。
