import React, { Component } from 'react'
import ReactDOM from 'react-dom'
import Pivot from './Pivot.jsx'

class PivotContainer {
    constructor(...args){
        this.config = {
            ...args[0]
        }
        this.render()
    }
    render(){
        let el = this.config.el
        ReactDOM.render(
        	<Pivot {...this.config} />,
        	document.getElementById(el)
        )
    }
}

export default PivotContainer
